module Schofield

  module Generators

    class Responses

      class << self; attr_accessor :generator, :re_ask end

      @file = File.join(Rails.root, 'tmp', 'answers.txt')


      def self.get question
        @question = question
        if re_ask || (answer = past_answer).nil?
          answer = ask
        end
        answer || ''
      end

      def self.ask
        re_ask = true
        answer = generator.ask(@question)
        @answers ||= {}
        @answers[@question] = answer || ''
      end

      def self.past_answer
        self.past_answers[@question]
      end

      def self.past_answers
        @answers ||= File.exists?(@file) ? File.open(@file, 'rb') { |f| Marshal.load(f) } : {}
      end

      def self.save
        File.open(@file, 'wb') { |io| Marshal.dump(@answers, io) }
      end

      def self.say string
        generator.say(string)
      end

    end

  end
end